# LaTeX2HTML site specific configuration file
# generated by config.pl

# You may edit this file to get around deficiencies of the configuration
# procedure, but you have to be sure of what you are doing!
# If you think there are bugs in the configuration procedure, please report
# them. See the BUGS file on how to do it. Your help is appreciated!

package cfgcache;
require Exporter;
# We should use this to locate gs !
# use Win32API::Registry qw(:ALL);
@ISA = qw(Exporter);
@EXPORT = qw(%cfg);

my $l2hdir = $ENV{'LATEX2HTML'};
if (! $l2hdir) {
  $l2hdir = `kpsewhich --expand-var \$SELFAUTOPARENT`;
  chomp $l2hdir;
}

$l2hdir =~ s@/@\\@g;
my $iconpath = $l2hdir;
$iconpath =~ s@^([A-Za-z]):@file:///$1|@;
$iconpath .= "/latex2html/icons";

$cfg{'BINDIR'} = "$l2hdir\\latex2html\\bin";
$cfg{'CRAYOLAFILE'} = "$l2hdir\\latex2html\\styles\\crayola.txt";
$cfg{'DVIPS'} = q'dvips.exe';
$cfg{'DVIPSOPT'} = q' -E';
$cfg{'GS'} = q'gswin32c.exe';
$cfg{'GSALIASDEVICE'} = q'ppmraw';
$cfg{'GSDEVICE'} = q'pnmraw';
$cfg{'GSLANDSCAPE'} = q'';
$cfg{'GS_LIB'} = q'';
$cfg{'HASHBANG'} = q'0';
$cfg{'HTML_VALIDATOR'} = q'';
$cfg{'ICONPATH'} = "$iconpath";
$cfg{'ICONSTORAGE'} = q'';
$cfg{'IMAGE_TYPES'} = q'png gif';
$cfg{'INITEX'} = q'initex.exe';
$cfg{'KPSEWHICH'} = q'kpsewhich.exe';
$cfg{'LATEX'} = q'latex.exe';
$cfg{'LATEX2HTMLDIR'} = "$l2hdir\\latex2html";
$cfg{'LIBDIR'} = "$l2hdir\\latex2html";
$cfg{'METADPI'} = q'180';
$cfg{'METAMODE'} = q'toshiba';
$cfg{'MKTEXLSR'} = q'mktexlsr.exe';
$cfg{'NULLFILE'} = q'nul:';
$cfg{'PBMMAKE'} = q'pbmmake.exe';
$cfg{'PERL'} = q'perl.exe';
$cfg{'PERLFOOTER'} = <<'EOQ';
__END__
:endofperl
EOQ
$cfg{'PERLHEADER'} = <<'EOQ';
@rem = '--*-Perl-*--
@echo off
set arg=
set prog=%0
:one
if "%1"=="" goto two
set arg=%arg% %1
shift
goto one
:two
if exist %prog%.bat goto indot
perl.exe -x -S %prog% %arg%
goto endofperl
:indot
perl.exe -x %prog%.bat %arg%
set arg=
set prog=
goto endofperl
@rem ';
#! perl -w
# line 21
EOQ
$cfg{'PERLSCRIPTDIR'} = q'd:\\Local\\perl\\bin';
$cfg{'PK_GENERATION'} = q'0';
$cfg{'PNMCAT'} = q'pnmcat.exe';
$cfg{'PNMCROP'} = q'pnmcrop.exe';
$cfg{'PNMFILE'} = q'pnmfile.exe';
$cfg{'PNMFLIP'} = q'pnmflip.exe';
$cfg{'PNMTOPNG'} = q'pnmtopng.exe';
$cfg{'PPMQUANT'} = q'ppmquant.exe';
$cfg{'PPMTOGIF'} = q'ppmtogif.exe';
$cfg{'PREFIX'} = "$l2hdir\\latex2html";
$cfg{'RGBCOLORFILE'} = "$l2hdir\\latex2html\\styles\\rgb.txt";
$cfg{'TEX'} = q'tex.exe';
$cfg{'TEXPATH'} = "$l2hdir\\texmf\\tex\\latex\\latex2html";
# $cfg{'TMPSPACE'} = q'C:\\DOCUME~1\\POPINE~1.NEV\\LOCALS~1\\Temp';
$cfg{'TMPSPACE'} = $ENV{TMP} || $ENV{TEMP} || '.';
$cfg{'WEB2C'} = q'1';
$cfg{'dd'} = q'\\';
$cfg{'distver'} = q'2K.1beta';
$cfg{'exec_extension'} = q'.bat';
$cfg{'gif_interlace'} = q'netpbm';
$cfg{'gif_trans'} = q'netpbm';
$cfg{'have_dvipsmode'} = q'1';
$cfg{'have_geometry'} = q'1';
$cfg{'have_images'} = q'1';
$cfg{'have_pstoimg'} = q'1';
$cfg{'perl_starter'} = q'perl.exe -x';
$cfg{'pipes'} = q'0';
$cfg{'plat'} = q'win32';
$cfg{'scriptdir'} = "$l2hdir\\latex2html\\bin";
$cfg{'scriptext'} = q'.bat';
$cfg{'srcdir'} = q'.';
$cfg{'texlive'} = q'0';
$cfg{'wrapper'} = q'0';

1; # must be last line
